function [Y, U, V] = extract_single_yuv(fname, cols, rows, frame_num) 
%
% extract one frame for yuv file
% extract_single_yuv(fname, cols, rows, frame_num) 
% start from frame number 0
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Example
% InName = ['C:\seq\champagne_tower_8bpc_420_1280x960_29_41p_view_40.yuv'];
% cols = 1280;
% rows = 960;
% [y u v] = extract_single_yuv(InName, cols, rows, 0);

%clear;
%close all;

%fin = 'c:\user\yinp\research\sequence\mumcrop_352x192_30.yuv';
%fout = 'mum_sand.yuv';
%start_frame = 930;
%numframes = 1;
%cols = 352;
%rows = 192;


fp_in = fopen(fname, 'rb');

%ignore number of frames equal to start_frames
pixels = cols*rows*1.5*frame_num;
%[ data, count ] = fread( fp_in, pixels, 'uint8' );
if (fseek(fp_in, pixels,-1)==-1)
    disp('Warning: End of file reached too early!')
end



%write numframes of sequence
%read Y
    pixels = cols*rows;
    [ data, count ] = fread( fp_in, pixels, 'uint8' );
    if ( count < pixels )
      disp( 'Warning: End of file reached too early.' );
    end
    Y = zeros(cols, rows);
    Y(1:count) = data;
    Y = Y';
    
    %read U
    pixels = pixels/4;
    [ data, count ] = fread( fp_in, pixels, 'uint8' );
    if ( count < pixels )
          disp( 'Warning: End of file reached too early.' );
    end
    U = zeros(cols/2, rows/2);
    U(1:count) = data;
    U = U';
    
    %read V
    [ data, count ] = fread( fp_in, pixels, 'uint8' );
    if ( count < pixels )
      disp( 'Warning: End of file reached too early.' );
    end
    V = zeros(cols/2, rows/2);
    
    V(1:count) = data;
    V = V';


fclose(fp_in);


pack;



